Subject: bug#51876: [External] : bug#51876: 28.0.60; Confusing prompt for setting a bookmark

From: Drew Adams <[email-masked]>
Date: Wed, 17 Nov 2021 17:46:10 +0000

> > The point is that you can have multiple bookmarks
> > with the same name.
> 
> Yes, but can you say that in few enough characters to fit a prompt, so
> that it is self-explanatory and yet short?  That's the challenge;
> everything else is a tangent, since it isn't like people here don't
> understand what that does.

I think you already said it in few chars: "Add",
not "Append".  "Add" is fine; "Append" is wrong.

Someone who suggests putting "append" in the
prompt seems to me not to understand well what
the command does.

Or else I just misunderstand their understanding.
In any case, to my mind "append" is wrong.  It
will only mislead or confuse users.

For vanilla Emacs, only one bookmark with a given
name can be used at any time.  Because of that, I
think "set" is a fine term to use.

The suggestion of "add" instead is OK too, but it
can wrongly suggest that other bookmarks with the
same name can be used at the same time.

And you'll note that "add" agrees with what's said
in the doc string of `bookmark-set-no-overwrite',
except there the word used is "push".

"Push" is thus another reasonable alternative
(like "add") to the incorrect "append".  Even
"prepend" more or less correct, but it's not as
good as "push", "add" (better than "push", or
"set" (best of all, IMO).
___

And speaking of (real) tangents -

This bug thread perhaps shouldn't have gone into
the weeds to deal with something different from
what you reported, which was, I think, a concern
that it isn't clear enough that what's prompted
for is a _bookmark_ name (not, e.g., a file name).
___

FWIW -

1. Bookmark+ uses the name
`bmkp-bookmark-set-confirm-overwrite' for a command
that requires confirmation before overwriting an
existing bookmark (unless you provide a prefix arg).

I prefer that name and behavior to what vanilla
Emacs added as command `bookmark-set-no-overwrite'.

2. With Bookmark+, it _is_ possible to use multiple
bookmarks that have the same name at the same time.
It's possible because the full bookmark is kept on
the bookmark name as a property.

This optional behavior is useful, for example to
(automatically) get bookmark names that are non-dir
file names, to files with the same name in different
directories.